{ Horse-Include-Datei hormovie.inc }

{ Globale Strukturen: }
{ nhorses:word, pferd: array[1..nhorses] of record x,y,phase,image,  }
{                       pferdename,reiter,alias,quoten,platz  end;   }
{ t1,t2,t3,t4,t5:string; Liste:array[1..nhorses] of word             }

{ -----------------  Feldanzeigen rechts oben ------------------- }
procedure anzg1;                             { Bahnen }
var i:integer;
begin
t1:='Bahn:';
rectfill(424,36,611,103,2);
setcolor(1);
outtextxy(429,36,t1);
setcolor(0);
outtextxy(428,36,t1);
for i:=1 to nhorses do with pferd[i] do begin
   str(i:1,t1);
   t1:=t1+'. ';
   t1:=t1+pferdename;
   setcolor(1);
   outtextxy(429,36+i*12,t1);
   setcolor(0);
   outtextxy(428,36+i*12,t1);
end;
end;


procedure anzg2(var liste:ivector);        { Einlauf }
var i:integer;
begin
t1:='Einlauf:';
rectfill(424,36,611,103,2);
setcolor(1);
outtextxy(429,36,t1);
setcolor(0);
outtextxy(428,36,t1);
for i:=1 to nhorses do with pferd[liste[i]] do begin
   str(i:1,t1);
   t1:=t1+'.#';
   str(liste[i]:1,t2);
   t1:=t1+t2+' ';
   t1:=t1+pferdename;
   setcolor(1);
   outtextxy(429,36+i*12,t1);
   setcolor(0);
   outtextxy(428,36+i*12,t1);
end;
end;

procedure anzg3(var liste:ivector);       { Quoten }
var i:integer;
    r:real;
begin
t1:='Quoten:';
rectfill(424,36,611,103,2);
setcolor(1);
outtextxy(429,36,t1);
setcolor(0);
outtextxy(428,36,t1);

for i:=1 to 3 do with pferd[liste[i]] do begin
   str(liste[i]:1,t1);
   t1:='#'+t1+' : ';
   case i of
   1: begin
         t1:=t1+'Sieg : ';
         r:=10.0/alphaquote(1,liste[i],2,3);
         if r>9999.0 then r:=9999.0;
         str(r:4:0,t2);
      end;
   2,3: begin
         t1:=t1+'Platz: ';
         r:=10.0/alphaquote(2,liste[i],2,3);
         if r>9999.0 then r:=9999.0;
         str(r:4:0,t2);
      end;
   end;
   t1:=t1+t2+':10';
   setcolor(1);
   outtextxy(429,36+i*12,t1);
   setcolor(0);
   outtextxy(428,36+i*12,t1);
end;

r:=10.0/alphaquote(3,liste[1],liste[2],liste[3]);
if r>9999.0 then r:=9999.0;
str(r:4:0,t1);
r:=10.0/alphaquote(4,liste[1],liste[2],liste[3]);
if r>9999.0 then r:=9999.0;
str(r:4:0,t2);
t1:='Zw.:'+t1+':10  E.:'+t2+':10';
setcolor(1);
outtextxy(429,36+4*12,t1);
setcolor(0);
outtextxy(428,36+4*12,t1);

r:=10.0/alphaquote(5,liste[1],liste[2],liste[3]);
if r>9999.0 then r:=9999.0;
str(r:4:0,t1);
r:=10.0/alphaquote(6,liste[1],liste[2],liste[3]);
if r>9999.0 then r:=9999.0;
str(r:4:0,t2);
t1:='Dr.:'+t1+':10  E.:'+t2+':10';
setcolor(1);
outtextxy(429,36+5*12,t1);
setcolor(0);
outtextxy(428,36+5*12,t1);
end;


procedure anzg4(var t1,t2,t3,t4:string);       { Events }
const t01='Die Wettleitung'; t02='verkndet:';
var i:integer;
    r:real;
begin
rectfill(424,36,611,103,2);
setcolor(1); outtextxy(429,36,t01);
setcolor(0); outtextxy(428,36,t01);
setcolor(1); outtextxy(449,46,t02);
setcolor(0); outtextxy(448,46,t02);

sound(440); delay(500); sound(550); delay(500);
sound(660); delay(1000); nosound;

setcolor(1); outtextxy(429,58,t1);
setcolor(0); outtextxy(428,58,t1);
setcolor(1); outtextxy(429,70,t2);
setcolor(0); outtextxy(428,70,t2);
setcolor(1); outtextxy(429,82,t3);
setcolor(0); outtextxy(428,82,t3);
setcolor(1); outtextxy(429,94,t4);
setcolor(0); outtextxy(428,94,t4);

end;


{ --------------------------------------------------------------- }

procedure anzeige2(t1,t2:string);
begin
rectfill(438,426,550,447,2);
setcolor(1);
outtextxy(439,426,t1);
outtextxy(439,438,t2);
setcolor(0);
outtextxy(438,426,t1);
outtextxy(438,438,t2);
end;


{ ------------------------------------------------------------------- }
procedure domovie(var liste:ivector; var ende:boolean);
{ boah, ey, war das ein Kampf mit dem Heap! }

var i1,i,j,k,x1,y1,dy:integer;
    size,anz:word;
    f:file;
    ok:boolean;
begin
{ --- Hintergrund laden --- }
   assign(f,bac1file);
   reset(f,1);
      BlockRead(f,backgr,sizeof(image),anz);
      with backgr do begin
         size:=imagesize(1,1,width,height);
         getmem(p_data,size);
         BlockRead(f,p_data^,size,anz)
      end;
   close(f);
   putimage(0,0,backgr.p_data^,normalput);
   freemem(backgr.p_data,size);
   assign(f,bac2file);
   reset(f,1);
      BlockRead(f,backgr,sizeof(image),anz);
      with backgr do begin
         size:=imagesize(1,1,width,height);
         getmem(p_data,size);
         BlockRead(f,p_data^,size,anz)
      end;
   close(f);
   putimage(0,128,backgr.p_data^,normalput);
   freemem(backgr.p_data,size);

   assign(f,bac3file);
   reset(f,1);
      BlockRead(f,backgr,sizeof(image),anz);
      with backgr do begin
         size:=imagesize(1,1,width,height);
         getmem(p_data,size);
         BlockRead(f,p_data^,size,anz)
      end;
   close(f);
   putimage(0,256,backgr.p_data^,normalput);
   freemem(backgr.p_data,size);
   assign(f,bac4file);
   reset(f,1);
      BlockRead(f,backgr,sizeof(image),anz);
      with backgr do begin
         size:=imagesize(1,1,width,height);
         getmem(p_data,size);
         BlockRead(f,p_data^,size,anz)
      end;
   close(f);
   putimage(560,256,backgr.p_data^,normalput);
   freemem(backgr.p_data,size);
   assign(f,bac5file);
   reset(f,1);
      BlockRead(f,backgr,sizeof(image),anz);
      with backgr do begin
         size:=imagesize(1,1,width,height);
         getmem(p_data,size);
         BlockRead(f,p_data^,size,anz)
      end;
   close(f);
   putimage(0,384,backgr.p_data^,normalput);
   freemem(backgr.p_data,size);
   anzeige2('ja, wo laufen','   sie denn?');

{ --- Rennen --- }

size:=imagesize(1,1,640,80);
getmem(backgr.p_data,size);
y1:=304;
dy:=-128;
for i:=1 to nhorses do with pferd[i] do begin
   x:=500;
   y:=pred(i)*10+y1;
   phase:=succ(i mod 4);
end;
rectfill(0,y1,559,y1+79,12);
rectfill(584,426,615,447,10);
{ SetVisualPage wird von der Cirrus 5424 leider nicht vertragen }

anzg1;
for i:=1 to nhorses do liste[i]:=0;
i:=0;
k:=0;
while k<nhorses do begin
   inc(i);
   setactivepage(1);
   rectfill(0,y1+dy,559,y1+dy+79,12);
   for j:=1 to nhorses do with pferd[j] do begin
      if x>1 then begin
         x:=trunc(560-0.05*speed*i-0.0002*i*i*(ausdauer-i/500)-0.03*kraft*i);
      { schweres Geluf: k-Faktor=0.05, normal: 0.025, hart:0.01 }
         phase:=succ(phase mod 4);
         if x<zielx then begin
            ok:=true;
            if k>0 then for i1:=1 to k do if j=liste[i1] then ok:=false;
            if ok then begin
               sound(1500); delay(10); nosound;
               inc(k);
               liste[k]:=j;
            end;
         end;
      end;
      putimage(x,y+dy,maske[phase].p_data^,andput);
      putimage(x,y+dy,pferd[j].ima[phase].p_data^,orput);
      if phase=1 then begin 
         sound(110); delay(10); nosound;
      end;
   end;
   getimage(0,y1+dy,559,y1+dy+79,backgr.p_data^);
   setactivepage(0);
   putimage(0,y1,backgr.p_data^,normalput);
end;
freemem(backgr.p_data,size);
anzg2(liste);
anzeige2('Weiter','mit Anykey');
repeat delay(50) until keypressed;  ende:=readkey=#27;
if not ende then begin
   anzg3(liste);
   delay(2500);
end;
end;
{ ------------------------------------------------------------------- }

procedure events(var liste:ivector; var ende:boolean);
var i,j,k:integer;
begin
randomize;
if random(100)<25 then begin
   j:=random(2) mod 2;
   case j of
   0: t1:='Der Jockey ist';
   1: t1:='Das Pferd ist';
   end;
   k:=random(5) mod 5;
   case k of
   0: t2:=' betrunken!';
   1: t2:=' gedopt!';
   2: if j=0 then t2:=' ein Ar...!' else t2:=' rossig!';
   3: if j=0 then t2:=' nicht im Club!' else t2:=' nicht reinrassig!';
   4: t2:=' untergeschoben';
   end;
   if k=4 then t3:='Die richtige Identitt:' else t3:='';
   if k=4 then t4:=pferd[liste[1]].alias else t4:='';
   anzg4(t1,t2,t3,t4);
   delay(2500);
   j:=liste[1];
   for i:=2 to nhorses do liste[pred(i)]:=liste[i];
   liste[nhorses]:=j;
   anzg2(liste);
   repeat delay(50) until keypressed;  ende:=readkey=#27;
   if not ende then begin
      anzg3(liste);
      delay(2500);
   end;
end;
end;

