program horserace;
{ UJA Vers. 1.00  04.10.94 }
{ 5 Pferde rennen um Ehre und Geld, und man kann dabei wetten.          }
{ Eingebaut sind: Sieg, Platz, Zweier und Dreier mit und ohne Einlauf.  }
{ Da meine Zeit und mein RAM knapp sind, ist diese Programm nicht ganz  }
{ so "durchgestylt" wir die anderen, aber Ihr bekommt ja den komplet-   }
{ ten Quelltext und knnt Euch ja dann an dem Heap die Zhne ausbeien! }
{ Lat aber dann "Sprockhveler Sturzacker" und "Darth Vader" drin!     }
{ Also ehrlich, 1 MB Chip-RAM an einem Streifen im Amiga ist nicht zu   }
{ verachten!                                                            }
{ --------------------------------------------------------------------- }

uses crt,dos,graph,bgidriv,drivers;

{$m 3000,0,655000 }

const inf0file='Horsera0.dat';      { Ro + Reiter, Ausgangsformen }
      inf1file='Horsera1.dat';      { Info zu Pferd 1 - 5 }
      horsfile='Horseph.ima';       { Intuition-Image, Pferde }
      bac1file='hback1.ima';      { Intuition-Image, HGR   0-128  }
      bac2file='hback2.ima';      { Intuition-Image, HGR 128-256  }
      bac3file='hback3.ima';      { Intuition-Image, HGR 256-384  }
      bac4file='hback4.ima';      { Intuition-Image, HGR 384-480  }
      bac5file='hback5.ima';      { Intuition-Image, rechter Baum }

      nhorses=5; maxplayer=5; maxcards=5; minmoney=5.00; maxmoney=1000.00;
      nphasen=4; zielx=72;

      type  image=record
                     x,y,width,height  :integer;
                     p_data,p_nextimage:pointer;
                  end;

            zocker=record
                     name:string;
                     geld:real;
                  end;

           gaul  =record
                     pferdename,alias,jockey :string;
                     speed,kraft,ausdauer,x,y:integer;
                     phase,quote,platz       :word;
                     ima                     :array[1..4] of Image;
                  end;

           karte =record
                     zockerid,wettyp:byte;
                     pferd          :array[1..3] of byte;
                     betrag         :real;
                  end;

           matrix=array[1..nhorses,1..nhorses] of real;
           ivector=array[1..nhorses] of byte;

var ok,ende,next  :boolean;
    mm,m1,m2,m3   :longint;
    i,j,k,nplayer,loop:integer;
    pferd         :array[1..nhorses] of gaul;
    spieler       :array[1..maxplayer] of zocker;
    wette         :array[1..maxplayer,1..maxcards] of karte;
    pferdinfo     :array[1..5,0..6] of string;
    maske         :array[1..4] of Image;
    backgr        :image;

    q,w           :matrix;
    liste         :ivector;
    r,pool        :real;
    ch            :char;
    t1,t2,t3,t4,t5:string;


{--- Intuit-Auszug --- }
{$i f:\inc\scrinit.inc }

procedure rectfill(x1,y1,x2,y2,co:integer);
const voll:FillPatternType=($ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff);
begin
   setfillpattern(voll,co); bar(x1,y1,x2,y2);
end;

procedure initmouse;
begin startupmode:=screenmode; initevents; showmouse; end;

procedure getmousexy(var key,mx,my:integer);
var regs:registers;
begin
 with regs do begin
    ax:=3;
    intr($33,regs);
    key:=bx;
    mx:=cx;
    my:=dx;
 end;
end;

procedure maustastelos(var key,mx,my:integer);
var regs:registers;
    k   :integer;
begin
 with regs do begin
    ax:=6;
    intr($33,regs);
    key:=bx;
 end;
 getmousexy(k,mx,my);
end;

{ ------------ }


procedure screencolors;
const pal:array[0..15,0..2] of word
         =((00,00,00),(63,63,63),(00,42,42),(63,52,39),
           (57,39,26),(52,25,15),(47,12,06),(30,00,00),
           (25,25,25),(34,34,34),(43,43,43),(52,52,52),
           (00,31,00),(00,38,00),(29,47,29),(48,63,47));
var i:word;
begin
   for i:=0 to 15 do begin
      setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]); setpalette(i,i);
   end;
end;

procedure getinfos;
var i,j:byte;
    f  :text;
begin
   assign(f,inf0file);
   reset(f);
   for i:=1 to nhorses do with pferd[i] do begin
      readln(f,pferdename);
      readln(f,alias);
      readln(f,jockey);
      readln(f,speed,kraft,ausdauer);
      quote:=9999;
   end;
   close(f);
   assign(f,inf1file);
   reset(f);
   for i:=1 to nhorses do with pferd[i] do begin
      for j:=0 to 6 do readln(f,pferdinfo[i,j]);
      readln(f);
   end;
   close(f);
end;


procedure getimages;
var f:file;
    i,j,k:byte;
    size,anz:word;
begin
   assign(f,horsfile);
   reset(f,1);
   for i:=1 to 4 do begin
      BlockRead(f,maske[i],sizeof(image),anz);
      with maske[i] do begin
         size:=imagesize(1,1,width,height);
         getmem(p_data,size);
         BlockRead(f,p_data^,size,anz)
      end;
   end;
   for j:=1 to nhorses do with pferd[j] do for i:=1 to 4 do begin
      BlockRead(f,ima[i],sizeof(image),anz);
      with ima[i] do begin
         size:=imagesize(1,1,width,height);
         getmem(p_data,size);
         BlockRead(f,p_data^,size,anz)
      end;
   end;
   close(f);
end;

{$i hwetten.inc }   { Wett-Screen und Wetten annehmen }
{$i hormovie.inc }  { Screen mit Renndarstellung und Rennbahn-Events }

{ ====================== Main ========================================== }
begin
getinfos;
initwmatrix;
pool:=0.0;
for i:=1 to maxplayer do with spieler[i] do begin
   name:='Zocker '+chr(48+i);
   geld:=250.00;
end;

nplayer:=0;
clrscr;
writeln(' H O R S E R A C E ');
writeln;
writeln('Halt! Bevor es losgeht, mu ich noch einiges ber Euch wissen!');
writeln('Bitte beantwortet folgende Fragen nach bestem Wissen und Gewissen!');
writeln;
write('Wieviele Zocker seid Ihr? Ich lasse 1 - ',maxplayer:1,' rein. -> ');
readln(nplayer);
ok:=nplayer in [1..maxplayer];

if ok then for i:=1 to nplayer do begin
   write('Zocker ',i,', wie ist Dein Name? ');
   readln(spieler[i].name);
   write('... und wieviel Geld hast Du mit? ');
   readln(spieler[i].geld);
   if spieler[i].geld<minmoney then begin
      writeln('Damit kannst Du hier nur zugucken!');
      delay(2500);
   end;
   if spieler[i].geld>maxmoney then begin
      writeln('Mafiosi haben hier keinen Zutritt!');
      writeln('Ich mu Dich bis auf ',maxmoney:8:2,' DM erleichtern.');
      spieler[i].geld:=maxmoney;
      delay(2500);
   end;
end;

{ ------------------------------------------------------------------------- }


if ok then initscreen(ok);
if ok then begin
   screencolors;
   getimages;
   initmouse;
   loop:=0;

repeat
{ -------------Teil 1, Wetten: ----------------------------------------- }
   zeichnewettscreen;
   for i:=1 to maxplayer do for j:=1 to maxcards do with wette[i,j] do begin
      betrag:=0.0;
      wettyp:=0;
      for k:=1 to 3 do pferd[k]:=0;
   end;
   i:=1;
   j:=1;
   repeat
      wetteannehmen(i,j,next,ende);
      if not (ende or next) then with wette[i,j] do begin
         ok:=(betrag>0.009) and (pferd[1] in [1..nhorses]);
         ok:=ok and (betrag<=spieler[i].geld);
         case wettyp of
         1,2: ;
         3,4: begin
                 ok:=ok and (pferd[2] in [1..nhorses]);
                 ok:=ok and (pferd[2]<>pferd[1]);
              end;
         5,6: begin
                 ok:=ok and (pferd[2] in [1..nhorses]);
                 ok:=ok and (pferd[3] in [1..nhorses]);
                 ok:=ok and (pferd[3]<>pferd[1]);
                 ok:=ok and (pferd[3]<>pferd[2]);
              end;
         else ok:=false;
         end;

         if ok then begin
            spieler[i].geld:=spieler[i].geld-betrag;
            wetteverbuchen(wettyp,pferd[1],pferd[2],pferd[3],betrag,pool);
            showquoten;
            inc(j);
            next:=next or (j>maxcards);
         end else begin
            sound(440); delay(200); nosound;
         end;
      end;
         if next then begin
            inc(i);
            j:=1;
         end;
   until (i>nplayer) or ende;

{ ----- Teil 2, Rennen ------------------------------------------- }
   mm:=maxavail;
   if not ende then begin
      for i:=1 to nhorses do with pferd[i] do begin
          speed:=speed+random(5)-2;
          kraft:=kraft+random(5)-2;
          ausdauer:=ausdauer+random(3)-2;
       end;
       domovie(liste,ende)
   end;
   if not ende then events(liste,ende);

{ ------- Teil 3, Auszahlung ------------------------------------- }
   if not ende then begin
      zeichnewettscreen;
     { --- Quoten anzeigen --- }
      rectfill(40,160,547,243,4);
      t1:=chr(49)+': '+pferd[liste[1]].pferdename+' - '
         +chr(50)+': '+pferd[liste[2]].pferdename+' - '
         +chr(51)+': '+pferd[liste[3]].pferdename;
         setcolor(3); outtextxy(41,160,t1);
         setcolor(7); outtextxy(40,160,t1);

      for k:=1 to 6 do begin
         mm:=trunc(10.0/alphaquote(k,liste[1],liste[2],liste[3])+0.5);
         str(mm:4,t2);
         t2:=t2+':10';
         case k of
         1: t1:='Sieg               : '+t2;
         2: begin
            t1:='Platz              : '+t2;
            mm:=trunc(10.0/alphaquote(k,liste[2],liste[1],liste[3])+0.5);
            str(mm:4,t2);
            t1:=t1+' '+t2+':10';
            mm:=trunc(10.0/alphaquote(k,liste[3],liste[2],liste[1])+0.5);
            str(mm:4,t2);
            t1:=t1+' '+t2+':10';
            end;
         3: t1:='Zweierwette        : '+t2;
         4: t1:='Zweierwette Einlauf: '+t2;
         5: t1:='Dreierwette        : '+t2;
         6: t1:='Dreierwette Einlauf: '+t2;
         end;
         setcolor(3); outtextxy(41,164+k*12,t1);
         setcolor(7); outtextxy(40,164+k*12,t1);
      end;
         t1:='Weiter mit <Taste>';
         rectfill(16,288,440,323,7);
         setcolor(1);
         outtextxy(24,296,t1);
      repeat delay(50) until keypressed;
      ende:=readkey=#27;
   end;

   if not ende then for i:=1 to nplayer do for j:=1 to maxcards do
   with wette[i,j] do if betrag>0.009 then begin
      r:=0.000;
      case wettyp of
      1: if liste[1]=pferd[1] then
         r:=betrag/alphaquote(wettyp,pferd[1],pferd[2],pferd[3]);
      2: if pferd[1] in [liste[1],liste[2],liste[3]] then
         r:=betrag/alphaquote(wettyp,pferd[1],pferd[2],pferd[3]);
      3: if (pferd[1] in [liste[1],liste[2]])
         and (pferd[2] in [liste[1],liste[2]]) then
         r:=betrag/alphaquote(wettyp,pferd[1],pferd[2],pferd[3]);
      4: if (pferd[1]=liste[1]) and (pferd[2]=liste[2]) then
         r:=betrag/alphaquote(wettyp,pferd[1],pferd[2],pferd[3]);
      5: if (pferd[1] in [liste[1],liste[2],liste[3]])
         and (pferd[2] in [liste[1],liste[2],liste[3]]) 
         and (pferd[3] in [liste[1],liste[2],liste[3]]) then
         r:=betrag/alphaquote(wettyp,pferd[1],pferd[2],pferd[3]);
      6: if (pferd[1]=liste[1]) and (pferd[2]=liste[2])
                                and (pferd[3]=liste[3]) then
         r:=betrag/alphaquote(wettyp,pferd[1],pferd[2],pferd[3]);
      end;
      if r>0.0 then begin
         mm:=trunc(r+0.5);
         spieler[i].geld:=spieler[i].geld+mm;
         sound(220); delay(500);
         sound(275); delay(500);
         sound(330); delay(500);
         sound(440); delay(1000);
         nosound;
         str(mm:8,t1);
         str(spieler[i].geld:8:0,t2);
         t1:=spieler[i].name+' gewann: '+t1+' DM und hat jetzt '+t2+' DM';
         t3:='Weiter mit <Taste>';
         rectfill(16,288,440,323,7);
         setcolor(1);
         outtextxy(24,296,t1);
         outtextxy(24,308,t3);
         repeat delay(50) until keypressed;
         ende:=readkey=#27;
      end;
   end;
   inc(loop);
until ende or (loop>5);

textmode(3);
for i:=1 to nplayer do
with spieler[i] do writeln(name,' verlt die Bahn mit ',geld:8:2,' DM');
end;
writeln('weiter mit Taste');
repeat delay(50) until keypressed;
ch:=readkey;
end.

